gtk-0.12.0: Binding to the Gtk+ graphical user interface library.

Portability | portable (depends on GHC)
Stability | provisional
Maintainer | gtk2hs-users@lists.sourceforge.net

Graphics.UI.Gtk.Display.Image

Contents

- Detail
- Class Hierarchy
- Types
- Constructors
- Methods
- Icon Sizes
- Attributes

Description

A widget displaying an image

Synopsis

- data Image
- class MiscClass o => ImageClass o
- castToImage :: GObjectClass obj => obj -> Image
- gTypeImage :: GType
- toImage :: ImageClass o => o -> Image
- data ImageType
  - = ImageEmpty
  - | ImagePixmap
  - | ImageImage
  - | ImagePixbuf
  - | ImageStock
  - | ImageIconSet
  - | ImageAnimation
  - | ImageIconName
  - | ImageGicon
- imageNewFromFile :: FilePath -> IO Image
- imageNewFromPixbuf :: Pixbuf -> IO Image
- imageNewFromAnimation :: PixbufAnimationClass animation => animation -> IO Image
- imageNewFromStock :: StockId -> IconSize -> IO Image
- imageNew :: IO Image
- imageNewFromIconName :: String -> IconSize -> IO Image
- imageGetPixbuf :: Image -> IO Pixbuf
- imageSetFromPixbuf :: Image -> Pixbuf -> IO ()
- imageSetFromAnimation :: PixbufAnimationClass animation => Image -> animation -> IO ()
- imageSetFromFile :: Image -> FilePath -> IO ()
- imageSetFromStock :: Image -> StockId -> IconSize -> IO ()
- imageSetFromIconName :: Image -> String -> IconSize -> IO ()
- imageSetPixelSize :: Image -> Int -> IO ()
- imageGetPixelSize :: Image -> IO Int
- imageClear :: Image -> IO ()
- data IconSize
  - = IconSizeInvalid
  - | IconSizeMenu
  - | IconSizeSmallToolbar
  - | IconSizeLargeToolbar
  - | IconSizeButton
  - | IconSizeDnd
  - | IconSizeDialog
  - | IconSizeUser Int
- imagePixbuf :: PixbufClass pixbuf => ReadWriteAttr Image Pixbuf pixbuf
- imagePixmap :: PixmapClass pixmap => ReadWriteAttr Image Pixmap pixmap
- imageAnimation :: (PixbufClass pixbuf, PixbufAnimationClass animation) => ReadWriteAttr Image animation pixbuf
- imageImage :: ImageClass image => ReadWriteAttr Image Image image
- imageMask :: PixmapClass pixmap => ReadWriteAttr Image Pixmap pixmap
- imageFile :: Attr Image String
- imageStock :: Attr Image String
- imageIconSize :: Attr Image Int
- imagePixelSize :: Attr Image Int
- imageIconName :: Attr Image String
- imageStorageType :: ReadAttr Image ImageType

# Detail

The `Image` widget displays an image. Various kinds of object can be displayed as an image; most typically, you would load a `Pixbuf` ("pixel buffer") from a file, and then display that. There's a convenience function to do this, `imageNewFromFile`, used as follows: If the file isn't loaded successfully, the image will contain a "broken image" icon similar to that used in many web browsers. If you want to handle errors in loading the file yourself, for example by displaying an error message, then load the image with `Graphics.UI.Gtk.Gdk.Pixbuf.pixbufNewFromFile`, then create the `Image` with `imageNewFromPixbuf`.

     image <- imageNewFromFile "myfile.png"

The image file may contain an animation, if so the `Image` will display an animation (`PixbufAnimation`) instead of a static image.

`Image` is a subclass of `Misc`, which implies that you can align it (center, left, right) and add padding to it, using `Misc` methods.

`Image` is a "no window" widget (has no `DrawWindow` of its own), so by default does not receive events. If you want to receive events on the image, such as button clicks, place the image inside a `EventBox`, then connect to the event signals on the event box.

When handling events on the event box, keep in mind that coordinates in the image may be different from event box coordinates due to the alignment and padding settings on the image (see `Misc`). The simplest way to solve this is to set the alignment to 0.0 (left/top), and set the padding to zero. Then the origin of the image will be the same as the origin of the event box.

Sometimes an application will want to avoid depending on external data files, such as image files. Gtk+ comes with a program to avoid this, called gdk-pixbuf-csource. This program allows you to convert an image into a C variable declaration, which can then be loaded into a `Pixbuf` using `Graphics.UI.Gtk.Gdk.Pixbuf.pixbufNewFromInline`.

# Class Hierarchy

     | GObject
     | +----Object
     | +----Widget
     | +----Misc
     | +----Image

# Types

data Image

Instances

Eq Image |
Ord Image |
GObjectClass Image |
ImageClass Image |
MiscClass Image |
WidgetClass Image |
ObjectClass Image |

class MiscClass o => ImageClass o

Instances

ImageClass Image |

castToImage :: GObjectClass obj => obj -> Image

gTypeImage :: GType

toImage :: ImageClass o => o -> Image

data ImageType

Describes the image data representation used by a `Image`. If you want to get the image from the widget, you can only get the currently-stored representation. e.g. if the `imageStorageType` is `ImagePixbuf`, then you can call `imageGetPixbuf` but not `imageGetStock`. For empty images, you can request any storage type (call any of the get functions), but they will all return `Nothing`.

Constructors

ImageEmpty |
ImagePixmap |
ImageImage |
ImagePixbuf |
ImageStock |
ImageIconSet |
ImageAnimation |
ImageIconName |
ImageGicon |

Instances

Enum ImageType |
Eq ImageType |
Show ImageType |

# Constructors

imageNewFromFile :: FilePath -> IO Image

Creates a new `Image` displaying the file `filename`. If the file isn't found or can't be loaded, the resulting `Image` will display a "broken image" icon.

If the file contains an animation, the image will contain an animation.

If you need to detect failures to load the file, use `Graphics.UI.Gtk.Gdk.Pixbuf.pixbufNewFromFile` to load the file yourself, then create the `Image` from the pixbuf. (Or for animations, use `Graphics.UI.Gtk.Gdk.Pixbuf.pixbufAnimationNewFromFile`).

The storage type (`imageGetStorageType`) of the returned image is not defined, it will be whatever is appropriate for displaying the file.

imageNewFromPixbuf :: Pixbuf -> IO Image

Creates a new `Image` displaying a `Pixbuf`.

Note that this function just creates an `Image` from the pixbuf. The `Image` created will not react to state changes. Should you want that, you should use `imageNewFromIconSet`.

imageNewFromAnimation :: PixbufAnimationClass animation => animation -> IO Image

imageNewFromStock

Arguments

:: StockId | `stockId` - a stock icon name
-> IconSize | `size` - a stock icon size
-> IO Image |

Creates a `Image` displaying a stock icon. If the stock icon name isn't known, the image will be empty.

imageNew :: IO Image

Creates a new empty `Image` widget.

imageNewFromIconName

Arguments

:: String | `iconName` - an icon name
-> IconSize | `size` - a stock icon size
-> IO Image |

Creates a `Image` displaying an icon from the current icon theme. If the icon name isn't known, a "broken image" icon will be displayed instead. If the current icon theme is changed, the icon will be updated appropriately.

- Available since Gtk+ version 2.6

# Methods

imageGetPixbuf :: Image -> IO Pixbuf

Gets the `Pixbuf` being displayed by the `Image`. The storage type of the image must be `ImageEmpty` or `ImagePixbuf` (see `imageGetStorageType`).

imageSetFromPixbuf :: Image -> Pixbuf -> IO ()

Overwrite the current content of the `Image` with a new `Pixbuf`.

imageSetFromAnimation :: PixbufAnimationClass animation => Image -> animation -> IO ()

imageSetFromFile :: Image -> FilePath -> IO ()

See `imageNewFromFile` for details.

imageSetFromStock

Arguments

:: Image |
-> StockId | `stockId` - a stock icon name
-> IconSize | `size` - a stock icon size
-> IO () |

See `imageNewFromStock` for details.

imageSetFromIconName

Arguments

:: Image |
-> String | `iconName` - an icon name
-> IconSize | `size` - an icon size
-> IO () |

See `imageNewFromIconName` for details.

- Available since Gtk+ version 2.6

imageSetPixelSize

Arguments

:: Image |
-> Int | `pixelSize` - the new pixel size
-> IO () |

Sets the pixel size to use for named icons. If the pixel size is set to a `value /= -1`, it is used instead of the icon size set by `imageSetFromIconName`.

- Available since Gtk+ version 2.6

imageGetPixelSize :: Image -> IO Int

Gets the pixel size used for named icons.

- Available since Gtk+ version 2.6

imageClear :: Image -> IO ()

Resets the image to be empty.

- Available since Gtk+ version 2.8

# Icon Sizes

data IconSize

The size of an icon in pixels.

- This enumeration contains one case that is not exported and which is used when new sizes are registered using `Graphics.UI.Gtk.General.IconFactory.iconSizeRegister`.
- Applying `show` to this type will reveal the name of the size that is registered with Gtk+.

Constructors

IconSizeInvalid | Don't scale but use any of the available sizes.
IconSizeMenu | Icon size to use in next to menu items in drop-down menus.
IconSizeSmallToolbar | Icon size for small toolbars.
IconSizeLargeToolbar | Icon size for larger toolbars.
IconSizeButton | Icon size for icons in buttons, next to the label.
IconSizeDnd | Icon size for icons in drag-and-drop.
IconSizeDialog | Icon size for icons next to dialog text.
IconSizeUser Int |

Instances

Enum IconSize |
Eq IconSize |
Show IconSize |

# Attributes

imagePixbuf :: PixbufClass pixbuf => ReadWriteAttr Image Pixbuf pixbuf

A `Pixbuf` to display.

imagePixmap :: PixmapClass pixmap => ReadWriteAttr Image Pixmap pixmap

A `Pixmap` to display.

imageAnimation :: (PixbufClass pixbuf, PixbufAnimationClass animation) => ReadWriteAttr Image animation pixbuf

imageImage :: ImageClass image => ReadWriteAttr Image Image image

A `Image` to display.

imageMask :: PixmapClass pixmap => ReadWriteAttr Image Pixmap pixmap

Mask bitmap to use with `Image` or `Pixmap`.

imageFile :: Attr Image String

Filename to load and display.

Default value: ""

imageStock :: Attr Image String

Stock ID for a stock image to display.

Default value: ""

imageIconSize :: Attr Image Int

Symbolic size to use for stock icon, icon set or named icon.

Allowed values: >= 0

Default value: 4

imagePixelSize :: Attr Image Int

The pixel-size property can be used to specify a fixed size overriding the icon-size property for images of type `ImageIconName`.

Allowed values: >= -1

Default value: -1

imageIconName :: Attr Image String

The name of the icon in the icon theme. If the icon theme is changed, the image will be updated automatically.

Default value: ""

imageStorageType :: ReadAttr Image ImageType

The representation being used for image data.

Default value: `ImageEmpty`